// simon.h - A simon says clone 
// (c) 2010  me@nikosapi.org  GPLv2

#include <stdint.h>

#define SLEEP_TIMEOUT 15 // seconds times 4 (15 is about 1 minute)

#define LIGHTS_PORT PORTB
#define LIGHTS_PIN  PINB
#define LIGHTS_DIR  DDRB
#define LIGHTS_PINS { PB1, PB2, PB3, PB4 }

// The buttons that must be pressed to initiate a reset
#define RESET_MASK (_BV(PB2) | _BV(PB3))




/* Function Prototypes */
uint16_t lfsr_rand();
void lfsr_load();
void lfsr_load_random_seed();
void lfsr_save();
void lfsr_generate_puzzle(uint8_t);
uint16_t get_random_seed();

void enable_sleep_timer();
void disable_sleep_timer();
void power_down();

void _blink_lights(uint8_t, uint16_t, uint16_t, uint8_t);
void blink_lights(uint8_t, uint16_t, uint16_t, uint8_t);
void delay_ms(uint16_t);
uint8_t real_mask(uint8_t);
void display_puzzle();

void _init();
